# coding: utf-8

"""
    Identity Service API

    A list of identity, account and service management APIs.  # noqa: E501

    OpenAPI spec version: 1.6.5
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from idem_vra.client.vra_identity_lib.api_client import ApiClient


class ServiceDefinitionV2ControllerApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_all_by_org_service_definitions(self, org_id, **kwargs):  # noqa: E501
        """Get all service definitions the organization has access to.  # noqa: E501

        ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x0274c; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_all_by_org_service_definitions(org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str org_id: (required)
        :param bool exclude_ungated:
        :param str locale:
        :param int page_start:
        :param int page_limit:
        :return: InlineResponse20015
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_all_by_org_service_definitions_with_http_info(org_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_all_by_org_service_definitions_with_http_info(org_id, **kwargs)  # noqa: E501
            return data

    def get_all_by_org_service_definitions_with_http_info(self, org_id, **kwargs):  # noqa: E501
        """Get all service definitions the organization has access to.  # noqa: E501

        ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x0274c; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_all_by_org_service_definitions_with_http_info(org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str org_id: (required)
        :param bool exclude_ungated:
        :param str locale:
        :param int page_start:
        :param int page_limit:
        :return: InlineResponse20015
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['org_id', 'exclude_ungated', 'locale', 'page_start', 'page_limit']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_all_by_org_service_definitions" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'org_id' is set
        if ('org_id' not in params or
                params['org_id'] is None):
            raise ValueError("Missing the required parameter `org_id` when calling `get_all_by_org_service_definitions`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'org_id' in params:
            path_params['orgId'] = params['org_id']  # noqa: E501

        query_params = []
        if 'exclude_ungated' in params:
            query_params.append(('excludeUngated', params['exclude_ungated']))  # noqa: E501
        if 'locale' in params:
            query_params.append(('locale', params['locale']))  # noqa: E501
        if 'page_start' in params:
            query_params.append(('pageStart', params['page_start']))  # noqa: E501
        if 'page_limit' in params:
            query_params.append(('pageLimit', params['page_limit']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/slc/api/v2/orgs/{orgId}/services', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20015',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_paged_service_definition_orgs(self, service_definition_id, **kwargs):  # noqa: E501
        """Get organizations with access to specified service.  # noqa: E501

        Currently all organizations have access to all of the service definitions. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x0274c; | | Organization Member | &#x0274c; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_paged_service_definition_orgs(service_definition_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str service_definition_id: (required)
        :param int page_start:
        :param int page_limit:
        :return: InlineResponse20016
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_paged_service_definition_orgs_with_http_info(service_definition_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_paged_service_definition_orgs_with_http_info(service_definition_id, **kwargs)  # noqa: E501
            return data

    def get_paged_service_definition_orgs_with_http_info(self, service_definition_id, **kwargs):  # noqa: E501
        """Get organizations with access to specified service.  # noqa: E501

        Currently all organizations have access to all of the service definitions. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x0274c; | | Organization Member | &#x0274c; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_paged_service_definition_orgs_with_http_info(service_definition_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str service_definition_id: (required)
        :param int page_start:
        :param int page_limit:
        :return: InlineResponse20016
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['service_definition_id', 'page_start', 'page_limit']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_paged_service_definition_orgs" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'service_definition_id' is set
        if ('service_definition_id' not in params or
                params['service_definition_id'] is None):
            raise ValueError("Missing the required parameter `service_definition_id` when calling `get_paged_service_definition_orgs`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'service_definition_id' in params:
            path_params['serviceDefinitionId'] = params['service_definition_id']  # noqa: E501

        query_params = []
        if 'page_start' in params:
            query_params.append(('pageStart', params['page_start']))  # noqa: E501
        if 'page_limit' in params:
            query_params.append(('pageLimit', params['page_limit']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/slc/api/v2/definitions/{serviceDefinitionId}/orgs', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20016',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
